<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;

class CheckRole
{
    /**
     * Handle an incoming request.
     *
     * @param  Closure(Request): (Response)  $next
     */
    public function handle(Request $request, Closure $next, ...$roles)
    {
        // Cek apakah user sudah login dan rolenya ada di daftar yang diizinkan
    if (!$request->user() || !in_array($request->user()->role, $roles)) {
        return response()->json([
            'status' => false,
            'message' => 'Akses ditolak! Anda tidak punya hak akses untuk aksi ini.'
        ], 403); // 403 artinya Forbidden
    }

    return $next($request);

    }
}
